# Support the following interface to the outside world.
#\begin{tabbing}
# #self.mostRecentPoint()#xxxxxxxxxxxxxxxx\=  Returns the point added most recently\kill
# #LineTracker(sensorIndex)# \> Creates a new line tracker using data from sensor \\
# \>with index #sensorIndex#\\
# #self.currentLine#   \>Variable containing the current line hypothesis\\
# #self.isLineValid#   \> Variable that's #True# when the line hypothesis is reasonable\\
# #self.update(robotPose, sonarHits, window)#  Updates the hypothesis based on the robot's odometry, \\
# \>and a list of all the sonar hits in local coordinates\\
# \>#window# is used for debugging information\\
#\end{tabbing}

import math

import lineFitter
from lineFitter import *
reload(lineFitter)

class LineTracker:
    def __init__(self, sensorIndex):
        # Index of sensor whose readings we're tracking
        self.sensorIndex = sensorIndex
        # The line fitter
        self.lineFit = LineFitter()
        # Is the current line valid?
        self.isLineValid = False
        self.currentLine = None
        # Remember this so we can delete old line from drawing
        self.windowLine = 0

    # Update tracker with a new reading.  Needs to know current pose of robot
    # in global coordinates
    def update(self, pose, sonarHits, window):

        localHit = sonarHits[self.sensorIndex]
        # Location of reading in global coordinates
        globalHit = pose.transform(localHit)

        # Your code here.  Remember to study the interface to LineFitter.
