# Support the following interface to the outside world.
#\begin{tabbing}
# #self.distToPoint()#xx\=  Returns the point added most recently\kill
# #Point(x, y)# \>Creates a new point\\
# #self.distToPoint(p)#      \>Returns the distance to point p\\
# #self.isNear(p)#  \>Returns #True# if point #p# is within #epsilon# of #self#\\
# #self.addPoint(p)#       \>Adds the point #p#, to #self#, changing #self#\\
# #self.scalePoint(a)#    \>Multiplies both coordinates of #self# by #a#\\
# #self.magnitude()#    \>Returns the distance form #self# to the origin\\
# #self.xytuple()#    \>Returns a tuple with the #x# and #y# coords of #self#\\
#\end{tabbing}


import math
epsilon = 0.000001

class Point:
    x = 0.0
    y = 0.0

    def __init__(self, x, y):
        self.x = x
        self.y = y

    def distToPoint(self, p):
        return math.sqrt((p.x - self.x)**2 + (p.y - self.y)**2)

    def isNear(self, p):
        return self.distToPoint(p) < epsilon

    # Add this point to self, and modify self
    def addPoint(self, p):
        self.x += p.x
        self.y += p.y

    def scalePoint(self, a):
        self.x = self.x * a
        self.y = self.y * a
        
    def magnitude(self):
        return math.sqrt(self.x**2 + self.y**2)

    def xytuple(self):
        return (self.x, self.y)
