# External interface:
# \begin{tabbing}
# #self.update(sonarDistances, robotPose)# \= \kill
# #self.update(sonarDistances, robotPose)# \> Updates internal state of the sensor.  Pose is optional\\
# #self.isValid()#     \>Returns #True# if the value is good\\
# #self.read(robotPose)# \>Return virtual sonar reading. Pose is necessary for this\\
# \>simple case, but useful for more complex virtual sensors.\\
# \end{tabbing}

class virtualSonar:

    def __init__(self, sensorIndex, window = None):
        # Remember what sensor we are tracking
        self.index = sensorIndex
        # A place to store the value
        self.value = 0.0
        self.valid = False

    # Update our internal state.  Pass in all the sonarDistances
    # because if we are averaging over space we might need to look at
    # more than one value.
    def update(self, sonarDistances, robotPose = None):
        self.value = sonarDistances[self.index]
        self.valid = True

    def read(self, robotPose = None):
        return self.value

    def isValid(self):
        return self.valid


    
